// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGDAMM_CONNECTION_H
#define _LIBGDAMM_CONNECTION_H

#include <glibmm.h>

/* $Id: connection.hg,v 1.7 2002/07/20 13:25:14 murrayc Exp $ */
// -*- C++ -*- // this is for the .hg, I realize gensig puts one in

/* connection.h
 * 
 * Copyright 2001      Free Software Foundation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgdamm/serverprovider.h>
#include <libgdamm/transaction.h>
#include <libgdamm/error.h>
#include <libgdamm/datamodel.h>
#include <libgda/gda-connection.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaConnection GdaConnection;
typedef struct _GdaConnectionClass GdaConnectionClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Gda
{ class Connection_Class; } // namespace Gda

} // namespace Gnome
namespace Gnome
{

namespace Gda
{


class Connection : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Connection CppObjectType;
  typedef Connection_Class CppClassType;
  typedef GdaConnection BaseObjectType;
  typedef GdaConnectionClass BaseClassType;

private:  friend class Connection_Class;
  static CppClassType connection_class_;

private:
  // noncopyable
  Connection(const Connection&);
  Connection& operator=(const Connection&);

protected:
  explicit Connection(const Glib::ConstructParams& construct_params);
  explicit Connection(GdaConnection* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Connection();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaConnection*       gobj()       { return reinterpret_cast<GdaConnection*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaConnection* gobj() const { return reinterpret_cast<GdaConnection*>(gobject_); }

  GdaConnection* gobj_copy();

private:

protected:
  explicit Connection(GdaClient* client, const Glib::RefPtr<ServerProvider>& provider, const Glib::ustring& dsn, const Glib::ustring& username, const Glib::ustring& password);

public:
  
  static Glib::RefPtr<Connection> create(GdaClient* client, const Glib::RefPtr<ServerProvider>& provider, const Glib::ustring& dsn, const Glib::ustring& username, const Glib::ustring& password);


  bool close();
  
  bool is_open();

  
  GdaClient* get_client();
  
  void set_client(GdaClient *client);

  
  Glib::ustring get_database() const;;
  
  Glib::ustring get_dsn() const;
  
  Glib::ustring get_cnc_string() const;
  
  Glib::ustring get_provider() const;
  
  Glib::ustring get_username() const;
  
  Glib::ustring get_password() const;

  
  void add_error(const Glib::RefPtr<Error>& error);
  
  void add_error_list(GList *error_list);

  
  bool change_database(const Glib::ustring& name);
  
  bool create_database(const Glib::ustring& name);
  
  bool drop_database (const Glib::ustring& name);

  
  GList* execute_command(GdaCommand *cmd, GdaParameterList *params);
  
  Glib::RefPtr<DataModel> execute_single_command(GdaCommand *cmd, GdaParameterList *params);
  
  int execute_non_query(GdaCommand *cmd, GdaParameterList *params);

  
  bool begin_transaction(const Glib::RefPtr<Transaction>& transaction);
  
  bool commit_transaction(const Glib::RefPtr<Transaction>& transaction);
  
  bool rollback_transaction(const Glib::RefPtr<Transaction>& transaction);

  //const GList   *gda_connection_get_errors (GdaConnection *cnc);

  
  bool supports(GdaConnectionFeature feature);


  Glib::RefPtr<DataModel> get_schema(GdaConnectionSchema schema, GdaParameterList *params);

  
  /**
   * @par Prototype:
   * <tt>void %error(GList* error_list)</tt>
   */
  Glib::SignalProxy1<void,GList*> signal_error();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_error(GList* error_list);


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Gda::Connection */
  Glib::RefPtr<Gnome::Gda::Connection> wrap(GdaConnection* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_CONNECTION_H */

